// vtkDoc.cpp : implementation of the CVtkDoc class
//

#include "stdafx.h"
//#include "ugview.h"

#include "vtkDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVtkDoc

IMPLEMENT_DYNCREATE(CVtkDoc, CDocument)

BEGIN_MESSAGE_MAP(CVtkDoc, CDocument)
	//{{AFX_MSG_MAP(CVtkDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVtkDoc construction/destruction

CVtkDoc::CVtkDoc()
{
	// TODO: add one-time construction code here
	this->m_reader = NULL;
	this->m_mapper = NULL;
	this->m_actor = NULL;
}

CVtkDoc::~CVtkDoc()
{
	if(this->m_reader!=NULL) {
		this->m_reader->Delete();
		this->m_reader = NULL;
	}
	if(this->m_mapper!=NULL) {
		this->m_mapper->Delete();
		this->m_mapper = NULL;
	}
	if(this->m_actor!=NULL) {
		this->m_actor->Delete();
		this->m_actor = NULL;
	}
}

BOOL CVtkDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	if(this->m_reader!=NULL) {
		this->m_reader->Delete();
		this->m_reader = NULL;
	}
	if(this->m_mapper!=NULL) {
		this->m_mapper->Delete();
		this->m_mapper = NULL;
	}
	if(this->m_actor!=NULL) {
		this->m_actor->Delete();
		this->m_actor = NULL;
	}

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CVtkDoc serialization

void CVtkDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CVtkDoc diagnostics

#ifdef _DEBUG
void CVtkDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CVtkDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CVtkDoc commands

BOOL CVtkDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	// TODO: Add your specialized creation code here
	if(this->m_reader!=NULL) {
		this->m_reader->Delete();
		this->m_reader = NULL;
	}
	if(this->m_mapper!=NULL) {
		this->m_mapper->Delete();
		this->m_mapper = NULL;
	}
	if(this->m_actor!=NULL) {
		this->m_actor->Delete();
		this->m_actor = NULL;
	}

  this->m_reader = vtkPolyDataReader::New();
  this->m_mapper = vtkPolyDataMapper::New();
  this->m_actor = vtkActor::New();	

	this->m_reader->SetFileName((char *) lpszPathName);
	this->m_mapper->SetInput(m_reader->GetOutput());
    this->m_mapper->ImmediateModeRenderingOn();
	this->m_actor->SetMapper(m_mapper);
	
	return TRUE;
}
